﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Tiles;

namespace XamTilesControl_SelectedItem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xamTilesControl1.ItemsSource = Person.GetPeople();
            xamTilesControl1.PreviewMouseLeftButtonDown += new MouseButtonEventHandler(xamTilesControl1_PreviewMouseLeftButtonDown);
        }

        void xamTilesControl1_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            TileHeaderPresenter tileHeader = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject,
                typeof(TileHeaderPresenter), true) as TileHeaderPresenter;
           
            // do not select when clicking on header
            if (tileHeader != null)
                return;

            Tile tile = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject,
                typeof(Tile), true) as Tile;
            if (tile != null)
            {
                tile.SetValue(SelectedTileProperty, true);
            }
        }


        public static bool GetSelectedTile(DependencyObject obj)
        {
            return (bool)obj.GetValue(SelectedTileProperty);
        }

        public static void SetSelectedTile(DependencyObject obj, bool value)
        {
            obj.SetValue(SelectedTileProperty, value);
        }

        public static readonly DependencyProperty SelectedTileProperty =
            DependencyProperty.RegisterAttached("SelectedTile", typeof(bool), typeof(XamTilesControl),
            new UIPropertyMetadata(false, new PropertyChangedCallback(OnSelectedTileChanged), new CoerceValueCallback(OnCoerceSelectedTile)));

        private static void OnSelectedTileChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
        }

        private static object OnCoerceSelectedTile(DependencyObject d, object value)
        {
            Tile tile = d as Tile;
            if (tile != null)
            {
                if ((bool)tile.GetValue(SelectedTileProperty) == true)
                {
                    return false;
                }
                else if ((bool)tile.GetValue(SelectedTileProperty) == false /*&& Keyboard.IsKeyDown(Key.LeftCtrl)*/)
                {
                    return true;
                }
            }
            return false;
        }
        
    }

}
